Index: NEMO/branches/2020/dev_12905_xios_restart/src/ABL/ablmod.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/ABL/ablmod.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/ABL/ablmod.F90	(revision 13727)
@@ -1029,5 +1287,5 @@
   &                 +zFY( ji, jj ) - zFY( ji, jj-1 )  )
       END_2D
-	  !!
+
 !---------------------------------------------------------------------------------------------------
    END SUBROUTINE smooth_pblh
Index: NEMO/branches/2020/dev_12905_xios_restart/src/ABL/ablrst.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/ABL/ablrst.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/ABL/ablrst.F90	(revision 13727)
@@ -109,5 +109,5 @@
       CALL iom_delay_rst( 'WRITE', 'ABL', numraw )   ! save only abl delayed global communication variables
 
-      ! Prognostic variables
+      ! Prognostic (after timestep + swap time indices = now timestep) variables
       CALL iom_rstput( iter, nitrst, numraw,   'u_abl',   u_abl(:,:,:,nt_n      ) )
       CALL iom_rstput( iter, nitrst, numraw,   'v_abl',   v_abl(:,:,:,nt_n      ) )
@@ -117,5 +117,5 @@
       CALL iom_rstput( iter, nitrst, numraw, 'avm_abl', avm_abl(:,:,:           ) )
       CALL iom_rstput( iter, nitrst, numraw, 'avt_abl', avt_abl(:,:,:           ) )
-      CALL iom_rstput( iter, nitrst, numraw, 'mxl_abl', mxl_abl(:,:,:           ) )
+      CALL iom_rstput( iter, nitrst, numraw,'mxld_abl',mxld_abl(:,:,:           ) )
       CALL iom_rstput( iter, nitrst, numraw,    'pblh',    pblh(:,:             ) )
       !
@@ -165,13 +165,13 @@
 
       ! --- mandatory fields --- ! 
-      CALL iom_get( numrar, jpdom_autoglo,   'u_abl',   u_abl(:,:,:,nt_n      ) )
-      CALL iom_get( numrar, jpdom_autoglo,   'v_abl',   v_abl(:,:,:,nt_n      ) )
-      CALL iom_get( numrar, jpdom_autoglo,   't_abl',  tq_abl(:,:,:,nt_n,jp_ta) )
-      CALL iom_get( numrar, jpdom_autoglo,   'q_abl',  tq_abl(:,:,:,nt_n,jp_qa) )
-      CALL iom_get( numrar, jpdom_autoglo, 'tke_abl', tke_abl(:,:,:,nt_n      ) )
-      CALL iom_get( numrar, jpdom_autoglo, 'avm_abl', avm_abl(:,:,:           ) )
-      CALL iom_get( numrar, jpdom_autoglo, 'avt_abl', avt_abl(:,:,:           ) )
-      CALL iom_get( numrar, jpdom_autoglo, 'mxl_abl', mxl_abl(:,:,:           ) )
-      CALL iom_get( numrar, jpdom_autoglo,    'pblh',    pblh(:,:             ) )
+      CALL iom_get( numrar, jpdom_auto,   'u_abl',   u_abl(:,:,:,nt_n      ), cd_type = 'U', psgn = -1._wp )
+      CALL iom_get( numrar, jpdom_auto,   'v_abl',   v_abl(:,:,:,nt_n      ), cd_type = 'V', psgn = -1._wp )
+      CALL iom_get( numrar, jpdom_auto,   't_abl',  tq_abl(:,:,:,nt_n,jp_ta) )
+      CALL iom_get( numrar, jpdom_auto,   'q_abl',  tq_abl(:,:,:,nt_n,jp_qa) )
+      CALL iom_get( numrar, jpdom_auto, 'tke_abl', tke_abl(:,:,:,nt_n      ) )
+      CALL iom_get( numrar, jpdom_auto, 'avm_abl', avm_abl(:,:,:           ) )
+      CALL iom_get( numrar, jpdom_auto, 'avt_abl', avt_abl(:,:,:           ) )
+      CALL iom_get( numrar, jpdom_auto,'mxld_abl',mxld_abl(:,:,:           ) )
+      CALL iom_get( numrar, jpdom_auto,    'pblh',    pblh(:,:             ) )
       CALL iom_delay_rst( 'READ', 'ABL', numrar )   ! read only abl delayed global communication variables
 
Index: NEMO/branches/2020/dev_12905_xios_restart/src/ABL/par_abl.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/ABL/par_abl.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/ABL/par_abl.F90	(revision 13727)
@@ -28,10 +28,11 @@
    LOGICAL , PUBLIC            ::   ln_hpgls_frc   !: forcing of ABL winds by large-scale pressure gradient 
    LOGICAL , PUBLIC            ::   ln_smth_pblh   !: smoothing of atmospheric PBL height 
+   !LOGICAL , PUBLIC            ::   ln_topbc_neumann = .FALSE.  !: idealised testcases only
 
-   LOGICAL           , PUBLIC ::   ln_rstart_abl    !: (de)activate abl restart
-   CHARACTER(len=256), PUBLIC ::   cn_ablrst_in     !: suffix of abl restart name (input)
-   CHARACTER(len=256), PUBLIC ::   cn_ablrst_out    !: suffix of abl restart name (output)
-   CHARACTER(len=256), PUBLIC ::   cn_ablrst_indir  !: abl restart input directory
-   CHARACTER(len=256), PUBLIC ::   cn_ablrst_outdir !: abl restart output directory
+   LOGICAL           , PUBLIC  ::   ln_rstart_abl    !: (de)activate abl restart
+   CHARACTER(len=256), PUBLIC  ::   cn_ablrst_in     !: suffix of abl restart name (input)
+   CHARACTER(len=256), PUBLIC  ::   cn_ablrst_out    !: suffix of abl restart name (output)
+   CHARACTER(len=256), PUBLIC  ::   cn_ablrst_indir  !: abl restart input directory
+   CHARACTER(len=256), PUBLIC  ::   cn_ablrst_outdir !: abl restart output directory
 
    !!---------------------------------------------------------------------
@@ -46,10 +47,12 @@
    REAL(wp), PUBLIC, PARAMETER ::   rn_Cek    = 258._wp                   !: Ekman constant for Richardson number 
    REAL(wp), PUBLIC, PARAMETER ::   rn_epssfc = 1._wp / ( 1._wp + 2.8_wp * 2.8_wp )
-   REAL(wp), PUBLIC            ::   rn_ceps                       !: namelist parameter
-   REAL(wp), PUBLIC            ::   rn_cm                         !: namelist parameter
-   REAL(wp), PUBLIC            ::   rn_ct                         !: namelist parameter
-   REAL(wp), PUBLIC            ::   rn_ce                         !: namelist parameter 
+   REAL(wp), PUBLIC            ::   rn_Ceps                       !: namelist parameter
+   REAL(wp), PUBLIC            ::   rn_Cm                         !: namelist parameter
+   REAL(wp), PUBLIC            ::   rn_Ct                         !: namelist parameter
+   REAL(wp), PUBLIC            ::   rn_Ce                         !: namelist parameter 
    REAL(wp), PUBLIC            ::   rn_Rod                        !: namelist parameter   
    REAL(wp), PUBLIC            ::   rn_Sch    
+   REAL(wp), PUBLIC            ::   rn_Esfc
+   REAL(wp), PUBLIC            ::   rn_Lsfc
    REAL(wp), PUBLIC            ::   mxl_min    
    REAL(wp), PUBLIC            ::   rn_ldyn_min                   !: namelist parameter
Index: NEMO/branches/2020/dev_12905_xios_restart/src/ABL/sbcabl.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/ABL/sbcabl.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/ABL/sbcabl.F90	(revision 13727)
@@ -71,12 +71,13 @@
          &                 ln_hpgls_frc, ln_geos_winds, nn_dyn_restore,           &
          &                 rn_ldyn_min , rn_ldyn_max, rn_ltra_min, rn_ltra_max,   &
-         &                 nn_amxl, rn_cm, rn_ct, rn_ce, rn_ceps, rn_Rod, rn_Ric, &
+         &                 nn_amxl, rn_Cm, rn_Ct, rn_Ce, rn_Ceps, rn_Rod, rn_Ric, &
          &                 ln_smth_pblh
       !!---------------------------------------------------------------------
 
-      ! Namelist namsbc_abl in reference namelist : ABL parameters
+                                        ! Namelist namsbc_abl in reference namelist : ABL parameters
       READ  ( numnam_ref, namsbc_abl, IOSTAT = ios, ERR = 901 )
 901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namsbc_abl in reference namelist' )
-      ! Namelist namsbc_abl in configuration namelist : ABL parameters
+      !
+                                        ! Namelist namsbc_abl in configuration namelist : ABL parameters
       READ  ( numnam_cfg, namsbc_abl, IOSTAT = ios, ERR = 902 )
 902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namsbc_abl in configuration namelist' )
@@ -165,4 +166,6 @@
       rn_Sch  = rn_ce / rn_cm
       mxl_min = (avm_bak / rn_cm) / sqrt( tke_min )
+      rn_Esfc =  1._wp / SQRT(rn_cm*rn_ceps)
+      rn_Lsfc = vkarmn * SQRT(SQRT(rn_cm*rn_ceps)) / rn_cm
 
       IF(lwp) THEN
@@ -171,5 +174,7 @@
          WRITE(numout,*) '    ~~~~~~~~~~~'
          IF(nn_amxl==0) WRITE(numout,*) 'Deardorff 80 length-scale '
-         IF(nn_amxl==1) WRITE(numout,*) 'length-scale based on the distance to the PBL height '
+         IF(nn_amxl==1) WRITE(numout,*) 'Modified Deardorff 80 length-scale '
+         IF(nn_amxl==2) WRITE(numout,*) 'Bougeault and Lacarrere length-scale '		 
+         IF(nn_amxl==3) WRITE(numout,*) 'Rodier et al. length-scale '	
          WRITE(numout,*) ' Minimum value of atmospheric TKE           = ',tke_min,' m^2 s^-2'
          WRITE(numout,*) ' Minimum value of atmospheric mixing length = ',mxl_min,' m'
@@ -178,4 +183,6 @@
          WRITE(numout,*) ' Constant for Schmidt number                = ',rn_Sch
          WRITE(numout,*) ' Constant for TKE dissipation               = ',rn_Ceps
+         WRITE(numout,*) ' Constant for TKE sfc boundary condition    = ',rn_Esfc
+         WRITE(numout,*) ' Constant for mxl sfc boundary condition    = ',rn_Lsfc
       END IF
 
@@ -202,4 +209,5 @@
       ! ABL timestep
       rDt_abl = nn_fsbc * rn_Dt
+      IF(lwp) WRITE(numout,*) ' ABL timestep = ', rDt_abl,' s'
 
       ! Check parameters for dynamics
@@ -248,7 +256,4 @@
          zcff         = 2._wp * omega * SIN( rad * 90._wp )   !++ fmax
          rest_eq(:,:) = SIN( 0.5_wp*rpi*( (fft_abl(:,:) - zcff) / zcff ) )**8
-         !!GS: alternative shape
-         !rest_eq(:,:) = SIN( 0.5_wp*rpi*(zcff - ABS(ff_t(:,:))) / (zcff - 3.e-5) )**8
-         !WHERE(ABS(ff_t(:,:)).LE.3.e-5) rest_eq(:,:) = 1._wp
       ELSE
          rest_eq(:,:) = 1._wp
@@ -271,6 +276,6 @@
          CALL fld_read( nit000, nn_fsbc, sf ) ! input fields provided at the first time-step
 
-         u_abl(:,:,:,nt_n      ) = sf(jp_wndi)%fnow(:,:,:)
-         v_abl(:,:,:,nt_n      ) = sf(jp_wndj)%fnow(:,:,:)
+          u_abl(:,:,:,nt_n      ) = sf(jp_wndi)%fnow(:,:,:)
+          v_abl(:,:,:,nt_n      ) = sf(jp_wndj)%fnow(:,:,:)
          tq_abl(:,:,:,nt_n,jp_ta) = sf(jp_tair)%fnow(:,:,:)
          tq_abl(:,:,:,nt_n,jp_qa) = sf(jp_humi)%fnow(:,:,:)
@@ -279,5 +284,4 @@
          avm_abl(:,:,:          ) = avm_bak
          avt_abl(:,:,:          ) = avt_bak
-         mxl_abl(:,:,:          ) = mxl_min
          pblh   (:,:            ) = ghw_abl( 3 )  !<-- assume that the pbl contains 3 grid points
          u_abl  (:,:,:,nt_a     ) = 0._wp
@@ -285,4 +289,7 @@
          tq_abl (:,:,:,nt_a,:   ) = 0._wp
          tke_abl(:,:,:,nt_a     ) = 0._wp
+
+         mxlm_abl(:,:,:         ) = mxl_min
+         mxld_abl(:,:,:         ) = mxl_min
       ENDIF
 
@@ -335,4 +342,5 @@
             &                tq_abl(:,:,2,nt_n,jp_ta), tq_abl(:,:,2,nt_n,jp_qa),   &   !   <<= in
             &                sf(jp_slp )%fnow(:,:,1) , sst_m, ssu_m, ssv_m     ,   &   !   <<= in
+            &                sf(jp_uoatm)%fnow(:,:,1), sf(jp_voatm)%fnow(:,:,1),   &   !   <<= in
             &                sf(jp_qsr )%fnow(:,:,1) , sf(jp_qlw )%fnow(:,:,1) ,   &   !   <<= in
             &                tsk_m, zssq, zcd_du, zsen, zevp                       )   !   =>> out
